#include "stdafx.h"

int NQ = 0;

void genmas(int n, int* &a)
{
	a = new int[n];
	for (int i = 0; i < n; i++)
		a[i] = rand() % 10000;

}

int input(const char * name, int* &a)
//   a   name, 
//     
//   -    ,
//   
{
	FILE * f = fopen(name, "rt");
	if (f == NULL) return 0;
	int n = 0; //    
	int k; //  
	
	while (fscanf(f, "%d", &k) != EOF) n++;

	rewind(f);
	
	if (n)
	{	a = new int[n];
		for (int i = 0; i < n; i++) 
			fscanf(f, "%d", &a[i]);
	}
	fclose(f);
	return n;
}

void output(int n, int *a)
{
	for (int i = 0; i < n; i++) printf("%4d ", a[i]);
	printf("\n");
}

void output(int L, int R, int *a)
{
	printf("%d:%d   ", L, R);
	for (int i = L; i<=R; i++) printf("%5d ", a[i]);
	printf("\n");
}


bool swap(int &x, int &y)
{
	int z = x; x = y; y = z;
	NQ++;
	return false;
}


void linesort(int n, int *a)
{
	for (int i = 0; i < n - 1; i++)
		for (int j = i + 1; j < n; j++)
			if (a[i] > a[j]) swap(a[i], a[j]);
}

void bubblesort(int n, int *a)
{
	for (int i = n - 1; i > 0; i--)
	{
		bool f = true;
		for (int j = 0; j < i; j++)
			if (a[j] > a[j+1]) f=swap(a[j], a[j+1]);
		if (f) break;
	}
}

void shakersort(int n, int * a)
{
	int L = 0;
	int R = n - 1;

	while (true)
	{
		bool f = true;
		for (int j = L; j < R; j++)
			if (a[j] > a[j+1]) f = swap(a[j], a[j+1]);
		if (f) break;
		R--;		// output(n, a);

		f = true;
		for (int j=R-1; j>=L; j--)
			if (a[j] > a[j+1]) f = swap(a[j], a[j+1]);
		if (f) break;
		L++;  		// output(n, a);
		
		
	}
}


void quicksort(int L, int R, int * &a)
{
	if (L >= R) return;
	int l = L;
	int r = R;
	int x = a[(L + R) / 2];
	do 
	{
		while (a[l]<x) l++;
		while (a[r]>x) r--;
		if (l <= r) 
		{
			swap(a[l], a[r]); l++; r--; 
		}
	} while (l <= r);
	
	quicksort(L, r, a);
	quicksort(l, R, a);
	
}


int main()
{
	int *a;
	int n = 100000;
	// n=input("Text.txt", a);
	genmas(n, a);
	output(1, 7, a); output(n-7, n-1, a);
	quicksort(0, n-1, a);
	// shakersort(n, a);
	printf("\n");
	output(1, 7, a); output(n - 7, n - 1, a);
	printf("NQ=%d\n", NQ);
	return 0;
}

